﻿#include <Adafruit_MPU6050.h>
#include <SoftwareSerial.h>
#include <Adafruit_Sensor.h>
#include <Wire.h>

Adafruit_MPU6050 mpu;

int tempo = 0;
float valorAntigox;
float valorAntigoy;
float valorAntigoz;
unsigned long lgUpdateTime;

SoftwareSerial bluetooth(14, 15); //TX, RX (Bluetooth)

void setup(void) {
  Serial.begin(9600);
  bluetooth.begin(9600);
  
  while (!Serial) {
    delay(10); // will pause Zero, Leonardo, etc until serial console opens
  }

  Serial.println("Adafruit MPU6050 test!");

  // Try to initialize!
  if (!mpu.begin()) {
    Serial.println("Failed to find MPU6050 chip");
    while (1) {
      delay(10);
    }
  }

  Serial.println("MPU6050 Found!");

  //setupt motion detection
  mpu.setHighPassFilter(MPU6050_HIGHPASS_0_63_HZ);
  mpu.setMotionDetectionThreshold(1);
  mpu.setMotionDetectionDuration(20);
  mpu.setInterruptPinLatch(true);  // Keep it latched.  Will turn off when reinitialized.
  mpu.setInterruptPinPolarity(true);
  mpu.setMotionInterrupt(true);

  Serial.println("");
  delay(100);
}

void loop() {
  /* Get new sensor events with the readings */
  sensors_event_t a, g, temp;
  mpu.getEvent(&a, &g, &temp);

	           if(millis() - lgUpdateTime > 2000)  //Loop approx every 2 seconds
               {
                         lgUpdateTime = millis();

                         while (tempo <= 2 ) {
                        
                           Serial.print("AccelX: "); Serial.print(a.acceleration.x);  Serial.println(",");
                           Serial.print("AccelY: "); Serial.print(a.acceleration.y);  Serial.println(",");
                           Serial.print("AccelZ: "); Serial.print(a.acceleration.z);  Serial.println(", ");
                           Serial.print("GyroX: ");  Serial.print(g.gyro.x);  Serial.println(",");
                           Serial.print("GyroY: ");  Serial.print(g.gyro.y);  Serial.println(",");
                           Serial.print("GyroZ: ");  Serial.println(g.gyro.z);
                           Serial.print("Tempo: "); Serial.println(tempo);
                           Serial.println("");
                        
                             bluetooth.print("ok");
                             bluetooth.println(); //Tells App "End of Data"
                        
                           if ((a.acceleration.x < 2.0) && (valorAntigox > 7.0)) {
                             Serial.println("Batida frontal");
                        
                             bluetooth.print("Batida");
                             bluetooth.println(); //Tells App "End of Data"
                           }
                        
                           if ((a.acceleration.x > 10.0) && (valorAntigox < 2.0)) {
                             Serial.println("Batida na traseira");
                        
                             bluetooth.print("Batida");
                             bluetooth.println(); //Tells App "End of Data"
                        
                           }
                        
                           if ((a.acceleration.y < 2.0) && (valorAntigoy > 4.0)) {
                             Serial.println("Batida lateral direita");
                        
                             bluetooth.print("Batida");
                             bluetooth.println(); //Tells App "End of Data"
                        
                           }
                        
                           if ((a.acceleration.y < -5.0) && (valorAntigoy > -1.0)) {
                             Serial.println("Batida lateral esquerda");
                        
                             bluetooth.print("Batida");
                             bluetooth.println(); //Tells App "End of Data"
                        
                           }
                        
                           if ((a.acceleration.z > -5.0) && (valorAntigoy < -8.0)) {
                             Serial.println("Capote");
                        
                             bluetooth.print("Batida");
                             bluetooth.println(); //Tells App "End of Data"
                        
                           }
                        
                           valorAntigox = a.acceleration.x;
                           valorAntigoy = a.acceleration.y;
                           valorAntigoz = a.acceleration.z;
                        
                           tempo = tempo + 1;
                           delay(1000);
                         }
                         tempo = 0;
               }
}
